## mingw-w64-boost-1.85.0-4.src.tar.zst

=== libs/unordered/CMakeLists.txt ===
# Generated by `boostdep --cmake unordered`
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.20)

project(boost_unordered VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_unordered INTERFACE)
add_library(Boost::unordered ALIAS boost_unordered)

target_include_directories(boost_unordered INTERFACE include)

target_link_libraries(boost_unordered
  INTERFACE
    Boost::assert
    Boost::config
    Boost::container_hash
    Boost::core
    Boost::mp11
    Boost::predef
    Boost::throw_exception
)

target_compile_features(boost_unordered INTERFACE cxx_std_11)

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()
